diff -Nur madwifi-trunk-r3314.orig/net80211/ieee80211_linux.c madwifi-trunk-r3314/net80211/ieee80211_linux.c
--- madwifi-trunk-r3314.orig/net80211/ieee80211_linux.c	2008-10-05 09:12:56.000000000 +0200
+++ madwifi-trunk-r3314/net80211/ieee80211_linux.c	2008-10-05 09:42:05.000000000 +0200
@@ -247,7 +247,11 @@
 
 	if (nstate == IEEE80211_S_RUN)
 		active = 1;
-	else if ((ostate >= IEEE80211_S_AUTH) && (nstate < ostate))
+	/*
+	 * Nbd has coded "ostate >= AUTH" here. Because wpa_supplicant frequently
+	 * switches between AUTH and SCAN, this leads to a lot of disconnects...
+	 */
+	else if ((ostate > IEEE80211_S_AUTH) && (nstate < ostate))
 		active = 0;
 	else
 		return;
